// 2.8 tri2.c
// Pascalλѷ()
#include <stdio.h>
#include <stdlib.h>

#ifdef FAST
int C[31][31];
#define reg(x,r,v) C[x][r]=(v)
#else
#define reg(x,r,v) (v)
#endif

int combi(int x, int r) {
#ifdef FAST
    if (C[x][r]>0) return C[x][r];
#endif
    if (r==0 || r==x) return reg(x,r,1);
    return reg(x,r,combi(x-1,r-1)+combi(x-1,r));
}

int main() {
    int n,d;
    scanf("%d",&n);
    if (n<0 || n>30) return 1;
    for (int x=0;x<=n;x++) {
       for (int r=x;r>=0;r--) {
	   d = combi(x,r);
#ifdef COLOR
           printf("\x1b[4%cm",  d%8+'0');
	   printf("\x1b[3%cm", (d%8)?'0':'7');
#endif
           printf("%8d",d);
       }
#ifdef COLOR
       printf("\x1b[m");
#endif
       printf("\n");
    }
    return 0;
}
