// 5 ϥ
// rule.h  롼
#ifndef _RULE_H_
#define _RULE_H_

#define MAXRULE 10

// ط
typedef enum   { dir_none, dir_U, dir_D, dir_L, dir_R } Dir;
Dir  getdir(Point from, Point to);
int  getdistance(Point from, Point to);

Point inter(Point from, Point to);
bool isjump(Point from, Point to);
bool isnext(Point from, Point to);

// 롼뷿
typedef bool (*Rule)(const Move*,const Board*);

// ץȥ
bool rule_black_move1(const Move*,const Board*);
bool rule_black_move2(const Move*,const Board*);
bool rule_white_move1(const Move*,const Board*);

bool check_rules(const Move *mp, const Board *bp);

#define LIMIT 1
bool check_black_win(const Board *bp);
bool check_white_win(const Board *bp);
Winner check_winner(const Board*);
void show_winner(Winner w);

#endif
