// 7.5 list.c(6.4ɲ)
#include <stdio.h>
#include <stdlib.h>

// ĶˤäƤ
typedef enum { false=0, true=1 } bool;

// ꥹȤη
typedef struct list {
    int    val;
    struct list *next;
} List;

// ƥоݤΥץȥ
void input_list(List *l) {
    int v;
    List *p=l;
    p->val = -1; // dummy

    while (scanf("%d", &v)>0) {
        List *newp = (List*)malloc(sizeof(List));
        newp->val = v;
        p->next = newp;
        p = p->next;
    }
}

// 
List *new_list(int n) {
    List *r = (List*)malloc(sizeof(List));
    List *p = r;
    p->val = -1;

    for (int i=0;i<n;i++) {
        List *newp = (List*)malloc(sizeof(List));
        newp->val = 0;
        p->next = newp;
        p = p->next;
    }
    return r;
}

// ̤ΥꥹȤ饳ԡ
List *copy(const List *l) {
    List *r = (List*)malloc(sizeof(List));
    List *p = r;
    p->val = -1;

    List *q = l->next;
    for (;q;q=q->next) {
        List *newp = (List*)malloc(sizeof(List));
        newp->val = q->val;
        p->next = newp;
        p = p->next;
    }
    return r;
}

// ꥹȤ礹. Ѳʤ
List *concat(const List *l1,const List *l2) {
    List *r = (List*)malloc(sizeof(List));
    List *p = r;
    p->val = -1;

    List *q = l1->next;
    for (;q;q=q->next) {
        List *newp = (List*)malloc(sizeof(List));
        newp->val = q->val;
        p->next = newp;
        p = p->next;
    }
    q = l2->next;
    for (;q;q=q->next) {
        List *newp = (List*)malloc(sizeof(List));
        newp->val = q->val;
        p->next = newp;
        p = p->next;
    }
    return r;
}

// ꥹȤ
void delete_list(List *l) {
    List *p = l->next;
    while (p) {
        List *newp = p->next;
        free(p);
        p = newp;
    }
    free(l);
}

// (ƥ)
void print_list(const List *l) {
   List *p = l->next;
   for (;p;p=p->next) {
       printf("(%d,0x%x)", p->val, p->next);
   }
   printf("\n");
}

// ꥹȤǤνʣ򸡺
bool duplicated(const List *l) {
    List *lp = l->next;
    for (; lp; lp=lp->next) {
        List *lp2 = lp->next;
        for (; lp2; lp2=lp2->next) {
            if (lp->val == lp2->val)
                return true;
        }
    }
    return false;
}

List list;

// ƥȴؿ
void test_list_op() {
    input_list(&list);
    List *x1 = new_list(3);
print_list(x1);
    List *x2 = copy(&list);
print_list(x2);
    List *x3 = concat(x2,x1);
print_list(x3);
    delete_list(x1);
print_list(x1);
    List *x4 = copy(x3);
print_list(x4);
}

int main() { test_list_op(); return 0; }
